package cs108;

import java.util.ArrayDeque;
import java.util.Deque;

import javafx.scene.shape.LineTo;
import javafx.scene.shape.MoveTo;
import javafx.scene.shape.Path;

public final class LSystemTracer {
    private LSystemTracer() {}

    public static Path paint(LSystem lSystem) {
        String s = lSystem.string();
        Turtle t = new Turtle();
        Deque<Turtle> turtleStack = new ArrayDeque<>();
        Path p = new Path();
        p.getElements().add(new MoveTo(t.x(), t.y()));
        for (int i = 0; i < s.length(); ++i) {
            char c = s.charAt(i);
            switch (c) {
            case '-':
                t = t.turned(-lSystem.turningAngle());
                break;
            case '+':
                t = t.turned(lSystem.turningAngle());
                break;
            case '[':
                turtleStack.addFirst(t);
                break;
            case ']':
                t = turtleStack.removeFirst();
                p.getElements().add(new MoveTo(t.x(), t.y()));
                break;
            default:
                if (lSystem.lineChars().contains(c)) {
                    t = t.moved(1);
                    p.getElements().add(new LineTo(t.x(), t.y()));
                }
                break;
            }
        }
        return p;
    }
}
